# coding: utf-8

"""
    Groupe PSA Connected Car - WEB API B2C

    *PSA B2C Connected Car API*  # Introduction This is the description of the *Groupe PSA Connected Car V2 API*. The speccification is  is based on **OpenAPI Specification version 3** and can be displayed via [ReDoc](https://github.com/Rebilly/ReDoc)a or [Swagger](http://swagger.io).   This API allows applications to fetch data from the connected Vehicles data platform. # Authentication PSA Connected Car APIs uses the [OAuth 2.0](https://tools.ietf.org/html/rfc6749) protocol for authentication and Authorization. any application require a valid [Access Token](https://tools.ietf.org/html/rfc6749#section-1.4) to access to user data. # Errors   Error codes returned by all REST APIs comply with the standard. Nevertheless, PSA Services (callers) need to have more complete data structures (even when the answer is not Http-OK) to better detail the type of error by providing application code, message and a debugging code(for investigation purposes). The http code of the response is managed by the protocol itself (in the header).      **Errors are  returned as a generic error response:**    * ```xError``` object model.       # noqa: E501

    OpenAPI spec version: 4.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class AdasParkAssist(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'front': 'list[str]',
        'rear': 'list[str]'
    }

    attribute_map = {
        'front': 'front',
        'rear': 'rear'
    }

    def __init__(self, front=None, rear=None):  # noqa: E501
        """AdasParkAssist - a model defined in Swagger"""  # noqa: E501

        self._front = None
        self._rear = None
        self.discriminator = None

        if front is not None:
            self.front = front
        if rear is not None:
            self.rear = rear

    @property
    def front(self):
        """Gets the front of this AdasParkAssist.  # noqa: E501


        :return: The front of this AdasParkAssist.  # noqa: E501
        :rtype: list[str]
        """
        return self._front

    @front.setter
    def front(self, front):
        """Sets the front of this AdasParkAssist.


        :param front: The front of this AdasParkAssist.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["Fault", "DriverInhibition", "Active", "Wait", "OutOfService"]  # noqa: E501
        if not set(front).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `front` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(front) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._front = front

    @property
    def rear(self):
        """Gets the rear of this AdasParkAssist.  # noqa: E501


        :return: The rear of this AdasParkAssist.  # noqa: E501
        :rtype: list[str]
        """
        return self._rear

    @rear.setter
    def rear(self, rear):
        """Sets the rear of this AdasParkAssist.


        :param rear: The rear of this AdasParkAssist.  # noqa: E501
        :type: list[str]
        """
        allowed_values = ["Fault", "DriverInhibition", "Active", "Wait", "OutOfService"]  # noqa: E501
        if not set(rear).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `rear` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(rear) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._rear = rear

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AdasParkAssist, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AdasParkAssist):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
